#pragma once
#include <string>
#include <vector>
#include "libs.h"
#include "star_system.h"

class CustomSBody;

class Sector {
public:
  /* Lightyears. */
  enum { SIZE=8 };
  Sector(int x, int y);
  static float DistanceBetween(const Sector* a, int sysIdxA, const Sector* b, int sysIdxB);

  struct System {
    std::string name;
    vector3f p;
    StarSystem::BodyType primaryStarClass;
    const CustomSBody* customDef;
  };
  std::vector<System>m_systems;

private:
  void GetCustomSystems(void);
  std::string GenName(MTRand& rand);
  int sx, sy;
};

